/*    Copyright (C) 2010  Tomasz Bursztyka
 *
 *  This program is free software: you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation, either version 3 of the License, or
 *  (at your option) any later version.
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */

#ifndef __IFACE_H__
#define __IFACE_H__

#include <stdlib.h>
#include <string.h>
#include <unistd.h>
#include <sys/types.h>
#include <sys/stat.h>
#include <fcntl.h>
#include <sys/ioctl.h>
#include <net/if.h>

#include <linux/if_tun.h>
/*#include <linux/ipv6.h>*/

#include <vpzone_internal.h>
#include <vpzone.h>
#include <log.h>

/*A temporary and *dirty* fix against bad headers 
on some system (<linux/ipv6.h> conflicting with <netinet/in.h>)...*/
#include <linux/types.h>
#include <linux/in6.h>
struct in6_ifreq 
{
	struct in6_addr ifr6_addr;
	__u32 ifr6_prefixlen;
	int ifr6_ifindex; 
};

#define MTU 1504

int open_tun_device(mdevice_t *mdevice);

int close_tun_device(mdevice_t *mdevice);

int set_device_name(mdevice_t *mdevice);

int set_device_persist(mdevice_t *mdevice, bool persist);

int set_device_address(mdevice_t *mdevice, struct in6_addr address, short prefix_len);

int set_device_up(mdevice_t *mdevice, bool up);

#endif
