/*    Copyright (C) 2010  Tomasz Bursztyka
 *
 *  This program is free software: you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation, either version 3 of the License, or
 *  (at your option) any later version.
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */

#ifndef __PLUGIN_H__
#define __PLUGIN_H__

#include <string.h>
#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <dlfcn.h>

#include <vpzone_internal.h>
#include <vpzone.h>
#include <ptable.h>
#include <hash.h>
#include <log.h>
#include <utils.h>
#include <command.h>
#include <configuration.h>

#define PLUGIN_DEFAULT_DIR VPZONE_LIB_DIR

int load_plugin(char *plugin_name);

int unload_plugin(char *plugin_name);

plugin_t *get_plugin_by_name(char *plugin_name);

int set_handler(handler_num_t handler_num, handler_t handler);

int unset_handler(handler_num_t handler_num);

int add_callback(callback_num_t handler_num, handler_t callback);

int sub_callback(callback_num_t handler_num, handler_t callback);

callback_t *insert_callback(callback_t *callback_cb, handler_t callback);

callback_t *remove_callback(callback_t *callback_cb, handler_t callback);

void setup_plugin_manager(void);

void deinit_plugin_manager(void);

int get_connector_id(char *type);

int get_cipher_id(char *type);

int get_authenticator_id(char *type);

#endif
