/*    Copyright (C) 2010  Tomasz Bursztyka
 *
 *  This program is free software: you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation, either version 3 of the License, or
 *  (at your option) any later version.
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */

#ifndef __SIMPLE_H__
#define __SIMPLE_H__

#include <inttypes.h>
#include <gnutls/gnutls.h>
#include <sys/types.h>
#include <sys/socket.h>
#include <arpa/inet.h>
#include <string.h>
#include <unistd.h>
#include <stdlib.h>

#include <vpzone_plugin.h>

#define SIMPLE_PACKET_ID 0x56505A /*"VPZ"*/
#define SIMPLE_PACKET_HDR_LEN 40

struct psimple_pkt_hdr
{
	uint32_t pkt_id;
	uint32_t cmd_id;
	uint32_t pkt_len;
	uint32_t unused1;
	uint64_t unused2;
	uint64_t unused3;
	uint64_t unused4;
};

enum simple_cmd_e
{
	CMD_NEW,
	CMD_UPDATE
};

struct simple_vp_ips
{
	struct in6_addr vp_uip;
	struct in6_addr vp_ip;
};

plugin_type_t init(int plugin_id, in_plugin_handlers_t *iph);

int unload(void);

void init_simple_protocol(callback_t *cb, mdevice_t *mdevice, mnode_t *mnode);

int handle_simple_packet(callback_t *cb, mdevice_t *mdevice, mnode_t *mnode);

#define SVP_PKT_ID(p_h) ntohl(((struct psimple_pkt_hdr *) p_h)->pkt_id)
#define SVP_CMD_ID(p_h) ntohl(((struct psimple_pkt_hdr *) p_h)->cmd_id)
#define SVP_PKT_LEN(p_h) ntohl(((struct psimple_pkt_hdr *) p_h)->pkt_len)

#endif
